package com.fjs.scenic.controller.system;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.fjs.scenic.controller.common.BaseController;
import com.fjs.scenic.dto.InputInfoDto;
import com.fjs.scenic.entity.system.InpIncome;
import com.fjs.scenic.entity.system.InputInfo;
import com.fjs.scenic.entity.system.Manage;
import com.fjs.scenic.entity.system.TypeAuthority;
import com.fjs.scenic.service.system.InpIncomeService;
import com.fjs.scenic.service.system.InputInfoService;
import com.fjs.scenic.service.system.TypeAuthorityService;
import com.fjs.scenic.service.system.impl.ManageServiceImpl;
import com.fjs.scenic.utils.Cons;
import com.fjs.scenic.utils.ReturnResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.security.Principal;
import java.time.LocalDate;
import java.util.Date;
import java.util.List;

/**
 * This class is used for ...
 *
 * @author lfj
 * @version 1.0
 * @CreateDate ${date} ${time}
 */
@RestController
@RequestMapping("/inputInfo")
public class InputInfoController {
    @Autowired
    private InputInfoService inputInfoService;
    @Autowired
    private InpIncomeService inpIncomeService;

    @GetMapping("/index")
    public ModelAndView sceniclist() {
        return new ModelAndView("system/inputInfo");
    }

    @PostMapping("/add")
    @Transactional(rollbackFor = Exception.class)
    public ReturnResult add(@RequestBody List<InputInfoDto> inputInfoDtos) {
        for (InputInfoDto inputInfoDto : inputInfoDtos) {
            inputInfoDto.setCreateTime(LocalDate.now());
            int sum = inputInfoService.count(new LambdaQueryWrapper<InputInfo>()
                    .eq(InputInfo::getStaticDate, inputInfoDto.getStaticDate())
                    .eq(InputInfo::getScenic, inputInfoDto.getScenic()));
            Assert.isTrue(sum == 0, "请勿重复添加");
            inputInfoService.save(inputInfoDto);
            if (inputInfoDto.getIncome()!=null){
                for (InpIncome inpIncome : inputInfoDto.getIncome()) {
                    inpIncome.setInputInfoId(inputInfoDto.getId());
                    inpIncomeService.save(inpIncome);
                }
            }
        }
        return ReturnResult.ok();
    }

}
